<?php if (!defined('PmWiki')) exit();
/**
 * phplm.php
 * @author V.Krishn (vkrishn@insteps.net), Copyright 2005-2014
 * @note This file is part of Cookbook recipe "Phplm" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 *
 * @category pmwiki/cookbook
 * @package phplm
 * @copyright Copyright (c) 2005-2014 V.Krishn (vkrishn@insteps.net)
 * @license GPL
 * @version 2.3.3
 */

global $Phplm;
if ( ! IsEnabled($EnablePhplm, 0)) return;

## Current script variables
    if ( ! defined('DS') ) { define('DS', DIRECTORY_SEPARATOR); }
    $Phplm['Current']['dir'] = dirname(__FILE__);
    $EnablePhplmDebug = 0; # 0=no debug, 1=debug messages, 2=all
    $Phplm['debug']['msg'] = array();

## Get cookbook/modules meta and version variables
## @todo xml version of the metapage
    if (file_exists($Phplm['Current']['dir'] . DS . "version.php")) {
      include_once($Phplm['Current']['dir'] . DS . "version.php");
    }

## Get wiki group and pagename for use
    $_t = FmtPageName('$Group', $pagename);
    $Phplm['page']['CurrentGroup'] = $_t ? $_t : $DefaultGroup;
    $_t = FmtPageName('$Name', $pagename);
    $Phplm['page']['CurrentName'] = $_t ? $_t : $DefaultName;

## Set default values for GROUP and default layermenu MENU script(wiki page)
    SDV($Phplm['default']['MenuGroupReserved'], 'Phplm'); #not implemented
    SDV($Phplm['default']['MenuPageGroup'], 'Content');
    SDV($Phplm['default']['MenuPageName'], 'Phplm');

// ========================================================
 /*
   NOTE: CAUTION
   Use of this recipe lets you insert arbitrary JavaScript Code.
   DO NOT disable the security code in "phplm.php".
   Make appropriate settings with the default password = menupass
     in phplm.php or in config.php if commenting below.
   Read main documentation on page protection and passwords.
   Simple security precaution below:
 */
  global $DefaultPasswords;
  $tmpLen = strlen($Phplm['default']['MenuPageName']);
  if ($Phplm['default']['MenuPageName'] === substr($pagename, -$tmpLen)) {
    $DefaultPasswords['edit'] = crypt('menupass');
    $DefaultPasswords['attr'] = crypt('menupass');
  }
// ========================================================

## Set modules/cookbook install variables.
## Change these values accordingly.
    SDV($Phplm['Install']['location'], '0'); # 0=field, 1=farm, 2=others
    SDV($Phplm['Install']['path'], 'cookbook'); # relative to field or farm
    SDV($Phplm['Install']['dir'], 'phplm'); # folder where installed
    SDV($Phplm['Install']['icon']['dir'], 'icons'); # icons to be used in menus


    // --------------------------------------
    // Would not require to edit below this
    // --------------------------------------




// //////////////////////////////////////////////////////////
//(:phplmDraw id orient theme pageType pageNameFormat:)
//    id - unique id
//    orient - horizontal,vertical
//    theme - gtk2,keramik...
//    pageType - page,group,site,default
//    pageNameFormat - #todo
// //////////////////////////////////////////////////////////

# improves full page edit performance, but preview would not be available
if ($action == 'edit') { return; }

if(function_exists('Markup_e')) {
  # new format, no /e , IMPORTANT: pmwiki-2.2.58+ and php 5.5x
  Markup('phplmDraw','directives','/\\(:phplmDraw(.*?):\\)/', 'CallbackPhplmDraw');
  Markup('phplmAllHeaderFooter','directives','/\\(:phplmAllHeaderFooter:\\)/', 'phplmALlHeaderFooter');
} else {
  /* old format, for pmwiki < 2.2.58
     if using php 5.5x see pmwiki documentation as how to suppress
       deprecated preg_replace errors. */
  Markup('phplmDraw','directives','/\\(:phplmDraw(.*?):\\)/e',"'<:block>'.phplmDraw('$1')");
  Markup('phplmAllHeaderFooter','directives','/\\(:phplmAllHeaderFooter:\\)/e',"phplmALlHeaderFooter()");
}

function CallbackPhplmDraw($m) { return phplmDraw($m[1]); }

$FmtPV['$phplmRequestUrl'] = '$_SERVER["REQUEST_URI"]';
$_s = preg_replace('/(.*?)('.$_SERVER['HTTP_HOST'].')(.*)/', '$3', $ScriptUrl,1);
$FmtPV['$phplmScriptUrl'] = "'$_s'";

function phplmDraw($params, $libonly=0, $_theme='default', $orient='') {
  global $Phplm, $lmInstallUrl,
         $HTMLHeaderFmt, $HTMLFooterFmt, $HTMLStylesFmt,
         $EnablePhplmDebug;
  static $phplmDrawCount; $phplmDrawCount++;
  include_once('scripts/functions.php');
  include_once('scripts/set_path_file.php');

  //shortname
  $lmInstallDir = &$Phplm['Current']['dir'];
  $lmInstallUrl = &$Phplm['Install']['dirUrl'];
  $lmInstallUrlPath = &$Phplm['Install']['dirUrlPath'];
  $lmIconDir = &$Phplm['Install']['icon']['dirFmt'];
  $lmIconUrl = &$Phplm['Install']['icon']['dirUrl'];
  $lmIconUrlPath = &$Phplm['Install']['icon']['dirUrlPath'];

  include_once('scripts/set_args_map.php');

  $lmZindex = '.defaultsubmenu, .mdksubmenu, .submenu, .ksubmenu { z-index: 410; }';
  SDV($Phplm['lm']['zindex'], $lmZindex); # z-index for dropdown submenus

  /*
   *  NOTE: Added ability to use menu in sidebar(workaround)
   *        URL:http://www.pmwiki.org/wiki/PITS/01139
   *  EXAMPLE: add in config.php or <group>.php or <page>.php in local
   *    phplmDraw('', 1, 'keramik'); //for dropdown menus
   *    phplmDraw('', 1, '', 'tree'); //for tree menus
   */
  if($libonly === 1) {
    phplm_set_lib($orient);
    //if($orient !== 'tree') {
      include_once('themes/themes.php');
      $_themeStyle = phplm_set_theme('', '', $_theme, 1);
      $HTMLHeaderFmt['phplm_'.$_theme] = phplm_make_html_header_link($_themeStyle)."\n";
      $HTMLStylesFmt['lmzindex'] = $Phplm['lm']['zindex'];
    //}
    return;
  }

  $lmDrawMap = getlmDrawMap($params);
  if($EnablePhplmDebug > 0) {
    $Phplm['debug']['msg']['lmDrawMap'][] = $lmDrawMap;
  }

  $Phplm['menuitem'][0]['id'] = $lmDrawMap['lmID'];
  $Phplm['menuitem'][0]['theme'] = $lmDrawMap['lmTheme']; //default
  $Phplm['menuitem'][0]['orient'] = $lmDrawMap['lmOrient']; //horizontal,vertical
  $Phplm['menuitem'][0]['pagetype'] = $lmDrawMap['lmPageType']; //page,group,site,default
  $Phplm['menuitem'][0]['pagesection'] = $lmDrawMap['lmPageSection']; //#section
  //$Phplm['menuitem'][0]['struct'] = 'dropdown'; //dropdown,tree //not in use

  if($EnablePhplmDebug > 0) {
    $Phplm['debug']['msg']['menuitem'][] = $Phplm['menuitem'][0];
  }

  include_once('scripts/set_menu_file.php');
  $Phplm['menu']['content'] =
      phplm_get_menu_text($Phplm['menuitem'][0]['pagetype'],
                          $Phplm['menuitem'][0]['pagesection']);

  if( $Phplm['menu']['content'] == '') {
    return '';
  } else {
    global $pagename;
    $Phplm['menu']['content'] = FmtPageName($Phplm['menu']['content'], $pagename);
  }

  if($Phplm['menuitem'][0]['orient'] === 'tree') {
    $Phplm['menuitem'][0]['instance'] = 'treemid';
    phplm_tree_init_lib('treemid', $lmDrawMap);
  } else {
    $Phplm['menuitem'][0]['instance'] = 'mid';
    phplm_init_lib('mid');
    $HTMLStylesFmt['lmzindex'] = $Phplm['lm']['zindex'];
  }

  $temp = phplm_set_menu($Phplm, 0);
  if($EnablePhplmDebug > 0) {
    //$Phplm['debug']['msg']['temp'][] = $temp;
  }


  ## Debug
  $phplmDebugMsg = PhplmDebug($EnablePhplmDebug);
  if($phplmDebugMsg) {
    @$HTMLFooterFmt['phplm_DEBUG'] =
        '<pre>' . $phplmDebugMsg . '</pre>' . "\n";
  }

  return keep(
      "\n\n".'<!--PhplmMenuFmt '.$lmDrawMap['lmID'].'-->'.
      "\n".$temp.
      "\n".'<!--/PhplmMenuFmt '.$lmDrawMap['lmID'].'-->'."\n\n"
  );

}


function phplmALlHeaderFooter() {
  if(function_exists('phplm_set_menu_header_footer')) {
    phplm_set_menu_header_footer('mid');
  }
 return;
}










