<?php if (!defined('PmWiki')) exit();
/**
 * functions.php
 * @author V.Krishn (vkrishn@insteps.net), Copyright 2005-2014
 * @note This file is part of Cookbook recipe "Phplm" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 * @package phplm
 */

// **********************************************************
// Some fuctions
// **********************************************************
  function phplm_get_file_format($mypagename, $filePath="uploads/Content", $fileExt="txt") {
    $lmfileFmt = "$filePath/$mypagename".".$_fileExt";
    return $lmfileFmt;
  }

  function phplm_get_file_content($f) {
    if (file_exists($f)) {
      $_filecontent = trim(file_get_contents($f));
      return $_filecontent;
    }
    return;
  }

  function phplm_get_page_content($lmpagename, $lmpagesection) {
    if (PageExists($lmpagename)) {
      if($lmpagesection) {
        $page['text'] = RetrieveAuthSection($lmpagename, $lmpagesection);
        } else { $page = RetrieveAuthPage($lmpagename,'read'); }
      if(@$page['text']) return $page['text'];
    }
    return;
  }

  function phplm_set_text_content(&$t='') {
    if(isset($t) && trim($t) !== '') {
      return trim($t);
    }
    return false;
  }

  function phplm_set_pagelist_content($lmpagename, $lmpagesection='') {
    $t = trim(phplm_get_page_content($lmpagename, $lmpagesection));
    $t = MarkupToHTML($pagename, $t, array('escape' => 0)); //use pagelist function
    $t = preg_replace('/(\\<br[\\s]*?\\/\\>|\\<p\\>|\\<\\/p\\>|\\n\\n)/s', '', $t);
    return phplm_set_text_content($t);
  }


  function phplm_get_lm_url($lmExtUrl) { #not implemented
    //if $lmExtUrl has $ScriptUrl in it then return
  }

  function phplm_make_html_header_link($href) {
    if (!$href) return;
    else {
      $htmlHeaderLink = "<link rel='stylesheet' href='$href' type='text/css' />";
      return $htmlHeaderLink;
    }
  }

  function phplm_set_menu(&$Phplm, $menuitem) {
    global $Phplm, $HTMLHeaderFmt;

    $Instance = $Phplm['menuitem'][$menuitem]['instance'];
    $Id = $Phplm['menuitem'][$menuitem]['id'];
    $Theme = $Phplm['menuitem'][$menuitem]['theme'];
    $Orient = $Phplm['menuitem'][$menuitem]['orient'];
    $PageType = $Phplm['menuitem'][$menuitem]['pagetype'];

    global $$Instance;

    if($Orient === 'tree') {
      static $tree_menu_count; $tree_menu_count++;
      $Phplm['tree_menu_count'] = $tree_menu_count;
      $themeStyle = phplm_set_theme($Instance, 'tree', $Theme);
    } else {
      static $menu_count; $menu_count++;
      $Phplm['menu_count'] = $menu_count;
      $themeStyle = phplm_set_theme($Instance, $Type, $Theme);
    }
    $HTMLHeaderFmt['phplm_'.$Theme] = phplm_make_html_header_link($themeStyle)."\n";

    $$Instance->setMenuStructureString($Phplm['menu']['content']);
    $$Instance->parseStructureForMenu($Id);

    if($Orient == 'tree') {
      $$Instance->newTreeMenu($Id);
      $$Id= $$Instance->getTreeMenu($Id);
    } else {

      if($Phplm['lm']['clickopen'] == 1) { $$Instance->isClickOpen = true; }

      if($Orient == 'horizontal' || $Orient == '') {
        $$Instance->newHorizontalMenu($Id);
      }
      if($Orient == 'vertical') {
        $$Instance->newVerticalMenu($Id);
      }

      $$Instance->isClickOpen = false;
      $$Id= $$Instance->getMenu($Id);
    }

    //$HTMLHeaderFmt[$Id] = '<div id=\''.$Id.'-wrapper'."'>\n" . $$Id . "\n</div>";
    $menuFmt = '<div id=\''.$Id.'-wrapper'."'>\n" . $$Id . "</div>";
    return $menuFmt;

  }



  ## Set header/footer
  // *******************************************
  function phplm_set_menu_header_footer($Instance) {
    global $$Instance, $Phplm, $HTMLHeaderFmt, $HTMLFooterFmt;
    if($Phplm['menu_count'] > 0) {
      $phplmHeader = $$Instance->getHeader();
      $phplmFooter = $$Instance->getFooter();
      $HTMLFooterFmt['phplmFooter1'] = "
        \n<!--phplmFooter1-->
        \n$phplmHeader
        \n<!--/phplmFooter1-->\n
        ";
      $HTMLFooterFmt['phplmFooter2'] = "
        \n<!--PhplmFooterFmt2-->
        \n$phplmFooter
        \n<!--/PhplmFooterFmt2-->\n
      ";
    }
    return;
  }
  // *******************************************

## Set PHPLM Menu/Tree library
// ***************************************
function phplm_set_lib($orient='') {
  global $Phplm, $HTMLHeaderFmt;
  //$lmInstallUrl = &$Phplm['Install']['dirUrl'];
  $lmInstallUrlPath = &$Phplm['Install']['dirUrlPath'];

$HTMLHeaderFmt['phplmCommonLib'] = "
<!--PhplmLibFmt-->
<script type='text/javascript' src='$lmInstallUrlPath/libjs/layersmenu-browser_detection.js'></script>
<!--/PhplmLibFmt-->
";

  include_once($Phplm['Current']['dir'].'/lib/PHPLIB.php');
  include_once($Phplm['Current']['dir'].'/lib/layersmenu-common.inc.php');

if($Phplm['menuitem'][0]['orient'] === 'tree' || $orient === 'tree') {

$lmIconUrlPath = &$Phplm['Install']['icon']['dirUrlPath'];
$HTMLHeaderFmt['phplm_treemenu'] = "
<!--PhplmLibFmt-->
<link rel='stylesheet' type='text/css' href='$lmInstallUrlPath/themes/default/layerstreemenu.css' />
<script type='text/javascript' src='$lmInstallUrlPath/libjs/layerstreemenu-cookies.js'></script>
<script type='text/javascript' src='$lmInstallUrlPath/libjs/layerstreemenu.js'></script>
<script type='text/javascript'><!--
_treemenu_toggle.data['icons'] = ['$lmIconUrlPath'];
// --></script>
<!--/PhplmLibFmt-->
";

} else {

$HTMLHeaderFmt['phplmLib'] = "
<!--PhplmLibFmt-->
<script type='text/javascript' src='$lmInstallUrlPath/libjs/layersmenu-library.js'></script>
<script type='text/javascript' src='$lmInstallUrlPath/libjs/layersmenu.js'></script>
<!--/PhplmLibFmt-->
";
  include_once($Phplm['Current']['dir'].'/lib/layersmenu.inc.php');

}
}


## Initiate phplayermenu lib
  function phplm_init_lib($Instance) {
    static $init_count;
    if($init_count < 1) {
      global $Phplm, $$Instance;
      phplm_set_lib();
      $$Instance = new LayersMenu();
      include_once($Phplm['Current']['dir'].'/themes/themes.php');
    }
    $init_count++;
    return;
  }

## Initiate phplayermenu tree lib
  function phplm_tree_init_lib($Instance, $dmap) {
    global $Phplm; static $init_count; $t = 'TreeMenu';
    $n = isset($dmap['type']) ? (int)$dmap['type'] : '';
    if( $n >= 2 && $n < 8 ) { $t = 'TreeMenu'.$n; } else { $n = ''; }
    if( $init_count !== $n ) {
      global $$Instance;
      phplm_set_lib();
      include_once($Phplm['Current']['dir'].'/lib/treemenu.inc.php');
      include_once($Phplm['Current']['dir'].'/lib/treemenu'.$n.'.inc.php'); //echo $n;
      $$Instance = new $t();
      include_once($Phplm['Current']['dir'].'/themes/themes.php');
    }
    $init_count = $n;
    return;
  }


// ****************************************



// **********************************************************

/**
 * Set/Show debug.
 * @param int value for debug level
 */
// *******************************************************
  function PhplmDebug($EnablePhplmDebug=0) {
    global $Phplm;
    if(1 === $EnablePhplmDebug) {
      $phplmDebugMsg = print_r($Phplm['debug']['msg'], true);
    }
    if(2 === $EnablePhplmDebug) {
      $phplmDebugMsg = print_r($Phplm, true);
    }
    return $phplmDebugMsg;
  }
// *******************************************************


